
<?php

//v1.50: Correctly orders results again (thanks, Tiffany in Oxnard CA, USA)
//       fix for uninitialised variable (thanks, Daryl in Harrison OH, USA)
//       debug now reports server's local time, which might be handy.
//       potential fix for events appearing on wrong day (thanks, Ashok)
//       replacement of deprecated eregi_replace (thanks, Sean in Iowa)
//       Updated 5 February 2012
//v1.41: Small fix for max-results, which had disappeared. Thanks, Pete in Chicago
//v1.40: ...and now we have a cache, thanks to Emilio Velis who got @ramayac to
//       write it for him. Which is excellent. Updated 21 February 2011
//v1.30: Daylight savings time *is*, honestly, now properly dealt with.
//       thanks Kevin Grewohl for pointing out that it wasn't! ;)
//       Updated 21 February 2011
//v1.20: Daylight savings time is now properly dealt with
//v1.10: This code now deals correctly with events that have a date range lasting more
//       than one day. Thank you, David Power, for the fix!
//v1.01: Some small bugfixes//30 Jun 2010
//v1.00: Rewrite to remove SimplePie completely, and simply use PHP's inbuilt XML parser.
//       Updated 29 June 2010
//v0.93: Added "make email addresses clickable". Thank you, Bjorn!
//v0.92: Fixed an issue with 'a section of dates' in amendable code. Thank you Kevin!
//v0.91: Nice error message if there are no events to display, requested by Tomas. Thanks!
//v0.90: Feature: clickable links in descriptions (start them http://). Thank you, Adam!
//       Feature: display end times, requested by Lucy. Thanks!
//       Feature: group by date, requested by Lucy. Thanks!
//       http://james.cridland.net/code


/////////
//Configuration
//

// Your private feed - which you get by right-clicking the 'xml' button in the 'Private Address' section of 'Calendar Details'.
if (!isset($calendarfeed)) {$calendarfeed = "https://www.google.com/calendar/feeds/bl1oj3iphimkctv7apr6pj70go%40group.calendar.google.com/private-5607017b43e08c7cd4d1dc55d7d098bf/basic/?maxResults=4&singleevents=true&futureevents=true&orderby=starttime&sortorder=a"; }
// Date format you want your details to appear
$monthformat="M"; // 10 March 2009 - see http://www.php.net/date for details

$dateformat="j"; // 10 March 2009 - see http://www.php.net/date for details
$timeformat="Y-m-d H:i:s"; // 12.15am

// The timezone that your user/venue is in (i.e. the time you're entering stuff in Google Calendar.) http://www.php.net/manual/en/timezones.php has a full list
date_default_timezone_set('America/New_York');

// How you want each thing to display.
// By default, this contains all the bits you can grab. You can put ###DATE### in here too if you want to, and disable the 'group by date' below.
$event_display = <<<'EOT'

<li>
<span class="schedule-date">###MONTH### <span class="schedule-day">###DATE###</span></span>
<span class="schedule-title">###TITLE###</span>
<span class="schedule-time">###FROM###-05:00</span>
</li>
EOT;

// What happens if there's nothing to display
$event_error="<li><span class=schedule-title>There are no events to display.</span></li>";

// The separate date header is here
$event_dateheader="";
$GroupByDate=true;
// Change the above to 'false' if you don't want to group this by dates.

// ...and how many you want to display (leave at 999 for everything)
$items_to_show=4;

// ...and here's where you tell it to use a cache.
// Your PHP will need to be able to write to a file called "gcal.xml" in your root. Create this file by SSH'ing into your box and typing these three commands...
// > touch gcal.xml
// > chmod 666 gcal.xml
// > touch -t 01101200 gcal.xml
// If you don't need this, or this is all a bit complex, change this to 'false'
$use_cache=false;


// Form the XML address.
$calendar_xml_address = $calendarfeed; //This goes and gets future events in your feed.

    $xml = simplexml_load_file($calendar_xml_address);


$items_shown=0;
$old_date="";
$xml->asXML();

foreach ($xml->entry as $entry) {
    $ns_gd = $entry->children('http://schemas.google.com/g/2005');

    //Do some niceness to the description
    //Make any URLs used in the description clickable
    $description = preg_replace('"\b(http://\S+)"', '<a href="$1">$1</a>', $entry->content);
    
    // Make email addresses in the description clickable
    $description = preg_replace("`([-_a-z0-9]+(\.[-_a-z0-9]+)*@[-a-z0-9]+(\.[-a-z0-9]+)*\.[a-z]{2,6})`i","<a href=\"mailto:\\1\" title=\"mailto:\\1\">\\1</a>", $description);


    // These are the dates we'll display
    $eventdated = str_replace("When: ", "", $entry->summary); 

    if (strpos($eventdated," to") == FALSE) {
        $eventdatea = substr($eventdated, 0, strpos($eventdated, "2014"));
        $month = date($monthformat, strtotime($eventdatea));
        $gCalDate = date($dateformat, strtotime($eventdatea));
        $gCalDateStart = "";
        $gCalDateEnd = "";
        $gCalStartTime = "";
        $gCalEndTime = "";
        $temp_event=$event_display;
        $temp_dateheader=$event_dateheader;
                $temp_event=str_replace("###FROM###","All Day",$temp_event);

    } else {
        $eventdateb = substr($eventdated, 0, strpos($eventdated, " to"));
        $month = date($monthformat, strtotime($eventdateb));
        $gCalDate = date($dateformat, strtotime($eventdateb));
        $gCalDateStart = date($dateformat, strtotime($eventdateb));
        $gCalDateEnd = date($dateformat, strtotime($eventdateb));
        $gCalStartTime = date($timeformat, strtotime($eventdateb));
        $gCalEndTime = date($timeformat, strtotime($eventdateb));
        $temp_event=$event_display;
        $temp_dateheader=$event_dateheader;
                $temp_event=str_replace("###FROM###",$gCalStartTime,$temp_event);

    }   


        $temp_event=str_replace("###TITLE###",$entry->title,$temp_event);
        $temp_event=str_replace("###DESCRIPTION###",$description,$temp_event);
        $temp_event=str_replace("###DATESTART###",'',$temp_event);
        $temp_event=str_replace("###DATEEND###",'',$temp_event);
        $temp_event=str_replace("###MONTH###",$month,$temp_event);
        $temp_event=str_replace("###DATE###",$gCalDate,$temp_event);
        $temp_dateheader=str_replace("###DATE###",$gCalDate,$temp_dateheader);
        $temp_event=str_replace("###UNTIL###",$gCalEndTime,$temp_event);
        $temp_event=str_replace("###LINK###",$entry->link->attributes()->href,$temp_event);
        $temp_event=str_replace("&lt;","<",$temp_event);
        $temp_event=str_replace("&gt;",">",$temp_event);
        $temp_event=str_replace("&quot;","\"",$temp_event);

                   

                   
    if (($items_to_show>0 AND $items_shown<$items_to_show)) {
                if ($GroupByDate) {if ($gCalDate!=$old_date) { echo $temp_dateheader; $old_date=$gCalDate;}}
        echo $temp_event;
        $items_shown++;
    }

}

if (!$items_shown) { echo $event_error; }
?>



